package com.moyoung.moyoung_ble_plugin.event;

import android.util.Log;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPBleConnectionStateListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.method.ConnectionMethodHandler;

import io.flutter.plugin.common.MethodCall;

class ConnectionStateHandler extends BaseConnectionEventChannelHandler {
    private final static String TAG = ConnectionStateHandler.class.getSimpleName();

    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setConnectionStateListener(newState -> {
            if (eventSink == null) {
                return;
            }

            switch (newState) {
                case CRPBleConnectionStateListener.STATE_CONNECTED:
                    ConnectionMethodHandler.isConnected = true;
                    break;
                case CRPBleConnectionStateListener.STATE_DISCONNECTED:
                    connection.close();
                default:
                    ConnectionMethodHandler.isConnected = false;
                    break;
            }

            activity.runOnUiThread(() -> eventSink.success(newState));
        });
    }

}
