package com.moyoung.moyoung_ble_plugin.event;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.listener.CRPFindPhoneListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.model.FindPhoneBean;

import io.flutter.plugin.common.MethodCall;

public class FindPhoneHandler extends BaseConnectionEventChannelHandler {
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setFindPhoneListener(new CRPFindPhoneListener() {
            @Override
            public void onFindPhone() {
                FindPhoneBean findPhoneBean = new FindPhoneBean(FindPhoneBean.FIND);
                String jsonStr = GsonUtils.get().toJson(findPhoneBean, FindPhoneBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onFindPhoneComplete() {
                FindPhoneBean findPhoneBean = new FindPhoneBean(FindPhoneBean.COMPLETE);
                String jsonStr = GsonUtils.get().toJson(findPhoneBean, FindPhoneBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }
}
