package com.moyoung.moyoung_ble_plugin.event;

import android.text.TextUtils;

import com.crrepa.ble.scan.bean.CRPScanDevice;
import com.crrepa.ble.scan.callback.CRPScanCallback;
import com.moyoung.moyoung_ble_plugin.base.BaseEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.model.ScanDeviceBean;

import java.util.List;

public class ScanDeviceHandler extends BaseEventChannelHandler {
    private static final int SCAN_PERIOD = 10 * 1000;

    public void startScan() {
        startScan(SCAN_PERIOD);
    }

    public void startScan(int scanPeriod) {
        bleClient.scanDevice(new CRPScanCallback() {
            @Override
            public void onScanning(CRPScanDevice device) {
                if (eventSink == null) {
                    return;
                }
                if (TextUtils.isEmpty(device.getDevice().getName())) {
                    return;
                }
                ScanDeviceBean scanDeviceBean = ScanDeviceBean.covert(false, device);
                String jsonStr = GsonUtils.get().toJson(scanDeviceBean, ScanDeviceBean.class);
                eventSink.success(jsonStr);
            }

            @Override
            public void onScanComplete(List<CRPScanDevice> list) {
                if (eventSink == null) {
                    return;
                }
                ScanDeviceBean scanDeviceBean = ScanDeviceBean.covert(true, null);
                String jsonStr = GsonUtils.get().toJson(scanDeviceBean, ScanDeviceBean.class);
                eventSink.success(jsonStr);
            }
        }, scanPeriod);

    }
}
