package com.moyoung.moyoung_ble_plugin.event;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPHistoryStressInfo;
import com.crrepa.ble.conn.bean.CRPTimingStressInfo;
import com.crrepa.ble.conn.listener.CRPStressListener;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.model.StressHandlerBean;

import java.util.List;

import io.flutter.plugin.common.MethodCall;

public class StressHandler extends BaseConnectionEventChannelHandler {
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setStressListener(new CRPStressListener() {
            @Override
            public void onSupportStress(boolean isSupport) {
                StressHandlerBean stressHandler = new StressHandlerBean(StressHandlerBean.SUPPORT, isSupport);
                String jsonStr = GsonUtils.get().toJson(stressHandler, StressHandlerBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onStressChange(int value) {
                StressHandlerBean stressHandler = new StressHandlerBean(StressHandlerBean.CHANGE, value);
                String jsonStr = GsonUtils.get().toJson(stressHandler, StressHandlerBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onHistoryStressChange(List<CRPHistoryStressInfo> list) {
                StressHandlerBean stressHandler = new StressHandlerBean(StressHandlerBean.HISTORY_CHANGE, list);
                String jsonStr = GsonUtils.get().toJson(stressHandler, StressHandlerBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onTimingStressStateChange(boolean state) {
                StressHandlerBean stressHandler = new StressHandlerBean(StressHandlerBean.TIMING_STATE_CHANGE, state);
                String jsonStr = GsonUtils.get().toJson(stressHandler, StressHandlerBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }

            @Override
            public void onTimingStressChange(CRPTimingStressInfo timingStressInfo) {
                StressHandlerBean stressHandler = new StressHandlerBean(StressHandlerBean.TIMING_CHANGE, timingStressInfo);
                String jsonStr = GsonUtils.get().toJson(stressHandler, StressHandlerBean.class);
                activity.runOnUiThread(() -> eventSink.success(jsonStr));
            }
        });
    }
}
