package com.moyoung.moyoung_ble_plugin.method;

import android.app.Activity;
import android.content.Context;
import android.util.Log;

import com.crrepa.ble.CRPBleClient;
import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.CRPBleDevice;
import com.crrepa.ble.conn.bean.CRPAlarmInfo;
import com.crrepa.ble.conn.bean.CRPCalendarEventInfo;
import com.crrepa.ble.conn.bean.CRPContactConfigInfo;
import com.crrepa.ble.conn.bean.CRPContactInfo;
import com.crrepa.ble.conn.bean.CRPDailyGoalsInfo;
import com.crrepa.ble.conn.bean.CRPDrinkWaterPeriodInfo;
import com.crrepa.ble.conn.bean.CRPElectronicCardCountInfo;
import com.crrepa.ble.conn.bean.CRPElectronicCardInfo;
import com.crrepa.ble.conn.bean.CRPFirmwareVersionInfo;
import com.crrepa.ble.conn.bean.CRPFutureWeatherInfo;
import com.crrepa.ble.conn.bean.CRPHandWashingPeriodInfo;
import com.crrepa.ble.conn.bean.CRPMessageInfo;
import com.crrepa.ble.conn.bean.CRPPeriodTimeInfo;
import com.crrepa.ble.conn.bean.CRPPhysiologcalPeriodInfo;
import com.crrepa.ble.conn.bean.CRPPillReminderInfo;
import com.crrepa.ble.conn.bean.CRPSedentaryReminderPeriodInfo;
import com.crrepa.ble.conn.bean.CRPSifliSupportWatchFaceInfo;
import com.crrepa.ble.conn.bean.CRPSupportWatchFaceInfo;
import com.crrepa.ble.conn.bean.CRPTodayWeatherInfo;
import com.crrepa.ble.conn.bean.CRPTrainingDayInfo;
import com.crrepa.ble.conn.bean.CRPUserInfo;
import com.crrepa.ble.conn.bean.CRPWatchFaceLayoutInfo;
import com.crrepa.ble.conn.bean.CRPWatchFaceStoreInfo;
import com.crrepa.ble.conn.callback.CRPAlarmCallback;
import com.crrepa.ble.conn.callback.CRPDeviceDisplayTimeCallback;
import com.crrepa.ble.conn.callback.CRPDeviceNewFirmwareVersionCallback;
import com.crrepa.ble.conn.callback.CRPDeviceSupportWatchFaceCallback;
import com.crrepa.ble.conn.callback.CRPDeviceWatchFaceCallback;
import com.crrepa.ble.conn.callback.CRPDeviceWatchFaceStoreCallback;
import com.crrepa.ble.conn.callback.CRPTrainingDayGoalsCallback;
import com.crrepa.ble.conn.callback.CRPWatchFaceDeleteCallback;
import com.crrepa.ble.conn.type.CRPBloodOxygenTimeType;
import com.crrepa.ble.conn.type.CRPDeviceLanguageType;
import com.crrepa.ble.conn.type.CRPDeviceVersionType;
import com.crrepa.ble.conn.type.CRPHeartRateType;
import com.crrepa.ble.conn.type.CRPHistoryDay;
import com.crrepa.ble.conn.type.CRPHistoryDynamicRateType;
import com.crrepa.ble.conn.type.CRPMetricSystemType;
import com.crrepa.ble.conn.type.CRPMovementHeartRateStateType;
import com.crrepa.ble.conn.type.CRPMusicPlayerStateType;
import com.crrepa.ble.conn.type.CRPStressDate;
import com.crrepa.ble.conn.type.CRPTempTimeType;
import com.crrepa.ble.conn.type.CRPTimeSystemType;
import com.crrepa.ble.conn.type.CRPTimingTempState;
import com.crrepa.ble.conn.type.CRPVibrationStrength;
import com.crrepa.ble.conn.type.CRPWatchFaceType;
import com.moyoung.moyoung_ble_plugin.base.BaseChannelHandler;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.event.ConnEveChlRegister;
import com.moyoung.moyoung_ble_plugin.model.BrightnessBean;
import com.moyoung.moyoung_ble_plugin.model.CalendarEventReminderTimeBean;
import com.moyoung.moyoung_ble_plugin.model.CheckFirmwareVersionBean;
import com.moyoung.moyoung_ble_plugin.model.ContactBean;
import com.moyoung.moyoung_ble_plugin.model.DeviceLanguageBean;
import com.moyoung.moyoung_ble_plugin.model.FirmwareVersionBean;
import com.moyoung.moyoung_ble_plugin.model.MaxHeartRateBean;
import com.moyoung.moyoung_ble_plugin.model.MenstrualCycleBean;
import com.moyoung.moyoung_ble_plugin.model.NotificationTypeBean;
import com.moyoung.moyoung_ble_plugin.model.OTABean;
import com.moyoung.moyoung_ble_plugin.model.PeriodTimeBean;
import com.moyoung.moyoung_ble_plugin.model.PillReminderBean;
import com.moyoung.moyoung_ble_plugin.model.TrainingDaysBean;
import com.moyoung.moyoung_ble_plugin.model.WatchFaceIDBean;
import com.moyoung.moyoung_ble_plugin.model.WatchFaceStoreBean;
import com.moyoung.moyoung_ble_plugin.model.WatchFaceStoreListBean;

import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import androidx.annotation.NonNull;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;

import static com.moyoung.moyoung_ble_plugin.ChannelNames.EVENT_CONTACT_AVATAR;
import static com.moyoung.moyoung_ble_plugin.ChannelNames.EVENT_ECG;
import static com.moyoung.moyoung_ble_plugin.ChannelNames.EVENT_FILE_TRANS;
import static com.moyoung.moyoung_ble_plugin.ChannelNames.EVENT_WF_FILE_TRANS;


public class ConnectionMethodHandler extends BaseChannelHandler implements MethodChannel.MethodCallHandler {
    private final static String TAG = ConnectionMethodHandler.class.getSimpleName();

    private final ConnEveChlRegister connEveChlRegister;
    private CRPBleDevice bleDevice;
    private CRPBleConnection bleConnection;
    public static boolean isConnected = false;

    public ConnectionMethodHandler(ConnEveChlRegister connEveChlRegister) {
        this.connEveChlRegister = connEveChlRegister;
    }

    @Override
    public void bindActivity(Activity activity) {
        super.bindActivity(activity);
        connEveChlRegister.bindActivity(this.activity);
    }

    public void unbindChannel(MethodChannel methodChannel) {
        methodChannel.setMethodCallHandler(null);
        connEveChlRegister.unregister();
    }

    @Override
    public void onMethodCall(@NonNull MethodCall call, @NonNull MethodChannel.Result result) {
        if (!checkBluetoothEnable()) {
            return;
        }
        if ("connect".equals(call.method)) {
            bleConnection = connect(call, activity.getApplicationContext());
            return;
        }

        if (bleConnection == null) {
            if ("isConnected".equals(call.method)) {
                isConnected(call, result);
            }
            return;
        }

        switch (call.method) {
            case "disconnect":
                disconnect(result);
                break;
            case "closeGatt":
                closeGatt(result);
                break;
            case "isConnected":
                isConnected(call, result);
                break;
            case "queryTime":
                bleConnection.syncTime();
                break;
            case "sendTimeSystem":
                sendTimeSystem(call);
                break;
            case "queryFirmwareVersion":
                queryFirmwareVersion(result);
                break;
            case "queryTimeSystem":
                queryTimeSystem(result);
                break;
            case "checkFirmwareVersion":
                checkFirmwareVersion(call, result);
                break;
            case "queryDeviceBattery":
                queryDeviceBattery();
                break;
            case "subscribeDeviceBattery":
                subscribeDeviceBattery();
                break;
            case "sendUserInfo":
                sendUserInfo(call);
                break;
            case "sendStepLength":
                sendStepLength(call);
                break;
            case "sendTodayWeather":
                sendTodayWeather(call);
                break;
            case "sendFutureWeather":
                sendFutureWeather(call);
                break;
            case "querySteps":
                querySteps();
                break;
            case "queryHistorySteps":
                queryHistorySteps(call);
                break;
            case "queryStepsDetail":
                queryStepsDetail(call);
                break;
            case "queryActionDetails":
                queryActionDetails(call);
                break;
            case "querySleep":
                querySleep();
                break;
            case "queryRemSleep":
                queryRemSleep();
                break;
            case "sendGoalSleepTime":
                sendGoalSleepTime(call);
                break;
            case "queryGoalSleepTime":
                queryGoalSleepTime();
                break;
            case "queryHistorySleep":
                queryHistorySleep(call);
                break;
            case "startOTA":
                startOTA(call);
                break;
            case "abortOTA":
                abortOTA(call);
                break;
            case "queryDeviceOtaStatus":
                queryDeviceOtaStatus(result);
                break;
            case "queryHsOtaAddress":
                queryHsOtaAddress(result);
                break;
            case "enableHsOta":
                enableHsOta();
                break;
            case "queryOtaType":
                queryOtaType(result);
                break;
            case "queryUnitSystem":
                queryUnitSystem(result);
                break;
            case "sendUnitSystem":
                sendUnitSystem(call);
                break;
            case "sendQuickView":
                sendQuickView(call);
                break;
            case "queryQuickView":
                queryQuickView(result);
                break;
            case "sendQuickViewTime":
                sendQuickViewTime(call);
                break;
            case "queryQuickViewTime":
                queryQuickViewTime(result);
                break;
            case "sendGoalSteps":
                sendGoalSteps(call);
                break;
            case "queryGoalSteps":
                queryGoalSteps(result);
                break;
            case "sendDailyGoals":
                sendDailyGoals(call);
                break;
            case "queryDailyGoals":
                queryDailyGoals(result);
                break;
            case "sendTrainingDayGoals":
                sendTrainingDayGoals(call);
                break;
            case "queryTrainingDayGoals":
                queryTrainingDayGoals(result);
                break;
            case "sendTrainingDays":
                sendTrainingDays(call);
                break;
            case "queryTrainingDay":
                queryTrainingDay(result);
                break;
            case "sendDisplayWatchFace":
                sendDisplayWatchFace(call);
                break;
            case "queryDisplayWatchFace":
                queryDisplayWatchFace(result);
                break;
            case "queryWatchFaceLayout":
                queryWatchFaceLayout(result);
                break;
            case "sendWatchFaceLayout":
                sendWatchFaceLayout(call);
                break;
            case "querySupportWatchFace":
                querySupportWatchFace(result);
                break;
            case "queryWatchFaceStore":
                queryWatchFaceStore(call, result);
                break;
            case "queryWatchFaceOfID":
                queryWatchFaceOfID(call, result);
                break;
            case "sendWatchFace":
                sendWatchFace(call);
                break;
            case "abortWatchFace":
                abortWatchFace();
                break;
            case "deleteWatchFace":
                deleteWatchFace(call, result);
                break;
            case "queryAvailableStorage":
                queryAvailableStorage(result);
                break;
            case "sendAlarm":
                sendAlarm(call);
                break;
            case "queryAllAlarm":
                queryAllAlarm(result);
                break;
            case "sendNewAlarm":
                sendNewAlarm(call);
                break;
            case "deleteNewAlarm":
                deleteNewAlarm(call);
                break;
            case "deleteAllNewAlarm":
                deleteAllNewAlarm();
                break;
            case "queryAllNewAlarm":
                queryAllNewAlarm(result);
                break;
            case "queryLastDynamicRate":
                queryLastDynamicRate(call);
                break;
            case "enableTimingMeasureHeartRate":
                enableTimingMeasureHeartRate(call);
                break;
            case "disableTimingMeasureHeartRate":
                disableTimingMeasureHeartRate();
                break;
            case "queryTimingMeasureHeartRate":
                queryTimingMeasureHeartRate(result);
                break;
            case "queryTodayHeartRate":
                queryTodayHeartRate(call);
                break;
            case "queryPastHeartRate":
                queryPastHeartRate(call);
                break;
            case "queryTrainingHeartRate":
                queryTrainingHeartRate();
                break;
            case "startMeasureOnceHeartRate":
                startMeasureOnceHeartRate();
                break;
            case "stopMeasureOnceHeartRate":
                stopMeasureOnceHeartRate();
                break;
            case "queryHistoryHeartRate":
                queryHistoryHeartRate();
                break;
            case "startMeasureBloodPressure":
                startMeasureBloodPressure();
                break;
            case "stopMeasureBloodPressure":
                stopMeasureBloodPressure();
                break;
            case "enableContinueBloodPressure":
                enableContinueBloodPressure();
                break;
            case "disableContinueBloodPressure":
                disableContinueBloodPressure();
                break;
            case "queryContinueBloodPressureState":
                queryContinueBloodPressureState();
                break;
            case "queryLast24HourBloodPressure":
                queryLast24HourBloodPressure();
                break;
            case "queryHistoryBloodPressure":
                queryHistoryBloodPressure();
                break;
            case "startMeasureBloodOxygen":
                startMeasureBloodOxygen();
                break;
            case "stopMeasureBloodOxygen":
                stopMeasureBloodOxygen();
                break;
            case "enableTimingMeasureBloodOxygen":
                enableTimingMeasureBloodOxygen(call);
                break;
            case "disableTimingMeasureBloodOxygen":
                disableTimingMeasureBloodOxygen();
                break;
            case "queryTimingBloodOxygenMeasureState":
                queryTimingBloodOxygenMeasureState();
                break;
            case "queryTimingBloodOxygen":
                queryTimingBloodOxygen(call);
                break;
            case "enableContinueBloodOxygen":
                enableContinueBloodOxygen();
                break;
            case "disableContinueBloodOxygen":
                disableContinueBloodOxygen();
                break;
            case "queryContinueBloodOxygenState":
                queryContinueBloodOxygenState();
                break;
            case "queryLast24HourBloodOxygen":
                queryLast24HourBloodOxygen();
                break;
            case "queryHistoryBloodOxygen":
                queryHistoryBloodOxygen();
                break;
            case "enterCameraView":
                enterCameraView();
                break;
            case "sendDelayTaking":
                sendDelayTaking(call);
                break;
//            case "queryDelayTaking":
//                queryDelayTaking();
//                break;
            case "exitCameraView":
                exitCameraView();
                break;
            case "readDeviceRssi":
                readDeviceRssi();
                break;
            case "setECGChangeListener":
                setECGChangeListener(call);
                break;
            case "startECGMeasure":
                startECGMeasure();
                break;
            case "stopECGMeasure":
                stopECGMeasure();
                break;
            case "isNewECGMeasurementVersion":
                isNewECGMeasurementVersion(result);
                break;
            case "queryLastMeasureECGData":
                queryLastMeasureECGData();
                break;
            case "sendECGHeartRate":
                sendECGHeartRate(call);
                break;
            case "sendWatchFaceBackground":
                sendWatchFaceBackground(call);
                break;
            case "abortWatchFaceBackground":
                abortWatchFaceBackground();
                break;
            case "sendDeviceLanguage":
                sendDeviceLanguage(call);
                break;
            case "queryDeviceVersion":
                queryDeviceVersion(result);
                break;
            case "queryDeviceLanguage":
                queryDeviceLanguage(result);
                break;
            case "sendOtherMessageState":
                sendOtherMessageState(call);
                break;
            case "queryOtherMessageState":
                queryOtherMessageState(result);
                break;
            case "sendMessage":
                sendMessage(call);
                break;
            case "endCall":
                endCall();
                break;
            case "sendCallContactName":
                sendCallContactName(call);
                break;
            case "queryMessageList":
                queryMessageList(result);
                break;
            case "sendSedentaryReminder":
                sendSedentaryReminder(call);
                break;
            case "querySedentaryReminderPeriod":
                querySedentaryReminderPeriod(result);
                break;
            case "sendSedentaryReminderPeriod":
                sendSedentaryReminderPeriod(call);
                break;
            case "querySedentaryReminder":
                querySedentaryReminder(result);
                break;
            case "findDevice":
                findDevice();
                break;
            case "shutDown":
                shutDown();
                break;
            case "reset":
                reset();
                break;
            case "sendDoNotDisturbTime":
                sendDoNotDisturbTime(call);
                break;
            case "queryDoNotDisturbTime":
                queryDoNotDisturbTime(result);
                break;
            case "sendBreathingLight":
                sendBreathingLight(call);
                break;
            case "queryBreathingLight":
                queryBreathingLight(result);
                break;
            case "sendMenstrualCycle":
                sendMenstrualCycle(call);
                break;
            case "queryMenstrualCycle":
                queryMenstrualCycle(result);
                break;
            case "startFindPhone":
                startFindPhone();
                break;
            case "stopFindPhone":
                stopFindPhone();
                break;
            case "setPlayerState":
                setPlayerState(call);
                break;
            case "sendSongTitle":
                sendSongTitle(call);
                break;
            case "sendLyrics":
                sendLyrics(call);
                break;
            case "closePlayerControl":
                closePlayerControl();
                break;
            case "sendCurrentVolume":
                sendCurrentVolume(call);
                break;
            case "sendMaxVolume":
                sendMaxVolume(call);
                break;
            case "enableDrinkWaterReminder":
                enableDrinkWaterReminder(call);
                break;
            case "disableDrinkWaterReminder":
                disableDrinkWaterReminder();
                break;
            case "queryDrinkWaterReminderPeriod":
                queryDrinkWaterReminderPeriod(result);
                break;
            case "setMaxHeartRate":
                setMaxHeartRate(call);
                break;
            case "queryMaxHeartRate":
                queryMaxHeartRate(result);
                break;
            case "startTraining":
                startTraining(call);
                break;
            case "setTrainingState":
                setTrainingState(call);
                break;
            case "getProtocolVersion":
                getProtocolVersion(result);
                break;
            case "startMeasureTemp":
                startMeasureTemp();
                break;
            case "stopMeasureTemp":
                stopMeasureTemp();
                break;
            case "enableTimingMeasureTemp":
                enableTimingMeasureTemp();
                break;
            case "disableTimingMeasureTemp":
                disableTimingMeasureTemp();
                break;
            case "queryTimingMeasureTempState":
                queryTimingMeasureTempState(result);
                break;
            case "queryTimingMeasureTemp":
                queryTimingMeasureTemp(call);
                break;
            case "sendDisplayTime":
                sendDisplayTime(call);
                break;
            case "queryDisplayTime":
                queryDisplayTime(result);
                break;
            case "enableHandWashingReminder":
                enableHandWashingReminder(call);
                break;
            case "disableHandWashingReminder":
                disableHandWashingReminder();
                break;
            case "queryHandWashingReminderPeriod":
                queryHandWashingReminderPeriod(result);
                break;
            case "sendLocalCity":
                sendLocalCity(call);
                break;
            case "sendTempUnit":
                sendTempUnit(call);
                break;
            case "queryTempUnit":
                queryTempUnit();
                break;
            case "sendBrightness":
                sendBrightness(call);
                break;
            case "queryBrightness":
                queryBrightness(result);
                break;
            case "queryBtAddress":
                queryBtAddress(result);
                break;
            case "checkSupportQuickContact":
                checkSupportQuickContact(result);
                break;
            case "queryContactCount":
                queryContactCount(result);
                break;
            case "queryContactNumberSymbol":
                queryContactNumberSymbol(result);
                break;
            case "sendContact":
                sendContact(call);
                break;
            case "sendContactAvatar":
                sendContactAvatar(call);
                break;
            case "deleteContact":
                deleteContact(call);
                break;
            case "deleteContactAvatar":
                deleteContactAvatar(call);
                break;
            case "clearContact":
                clearContact();
                break;
            case "queryBatterySaving":
                queryBatterySaving();
                break;
            case "sendBatterySaving":
                sendBatterySaving(call);
                break;
            case "queryPillReminder":
                queryPillReminder(result);
                break;
            case "sendPillReminder":
                sendPillReminder(call);
                break;
            case "deletePillReminder":
                deletePillReminder(call);
                break;
            case "clearPillReminder":
                clearPillReminder();
                break;
            case "queryWakeState":
                queryWakeState(result);
                break;
            case "querySupportStress":
                querySupportStress();
                break;
            case "startMeasureStress":
                startMeasureStress();
                break;
            case "stopMeasureStress":
                stopMeasureStress();
                break;
            case "queryHistoryStress":
                queryHistoryStress();
                break;
            case "enableTimingStress":
                enableTimingStress();
                break;
            case "disableTimingStress":
                disableTimingStress();
                break;
            case "queryTimingStressState":
                queryTimingStressState();
                break;
            case "queryTimingStress":
                queryTimingStress(call);
                break;
            case "queryElectronicCardCount":
                queryElectronicCardCount(result);
                break;
            case "sendElectronicCard":
                sendElectronicCard(call);
                break;
            case "deleteElectronicCard":
                deleteElectronicCard(call);
                break;
            case "queryElectronicCard":
                queryElectronicCard(call, result);
                break;
            case "sendElectronicCardList":
                sendElectronicCardList(call);
                break;
            case "sendWakeState":
                sendWakeState(call);
                break;
            case "queryHistoryTraining":
                queryHistoryTraining();
                break;
            case "queryTraining":
                queryTraining(call);
                break;
            case "sendGsensorCalibration":
                sendGsensorCalibration();
                break;
            case "enableContinueTemp":
                enableContinueTemp();
                break;
            case "disableContinueTemp":
                disableContinueTemp();
                break;
            case "queryContinueTempState":
                queryContinueTempState();
                break;
            case "queryLast24HourTemp":
                queryLast24HourTemp();
                break;
            case "createBond":
                createBond(call, result);
                break;
            case "querySupportNewHrv":
                querySupportNewHrv();
                break;
            case "startMeasureNewHrv":
                startMeasureNewHrv();
                break;
            case "stopMeasureNewHrv":
                stopMeasureNewHrv();
                break;
            case "queryHistoryNewHrv":
                queryHistoryNewHrv();
                break;
            case "querySupportCalendarEvent":
                querySupportCalendarEvent();
                break;
            case "sendCalendarEvent":
                sendCalendarEvent(call);
                break;
            case "deleteCalendarEvent":
                deleteCalendarEvent(call);
                break;
            case "queryCalendarEvent":
                queryCalendarEvent(call);
                break;
            case "sendCalendarEventReminderTime":
                sendCalendarEventReminderTime(call);
                break;
            case "queryCalendarEventReminderTime":
                queryCalendarEventReminderTime();
                break;
            case "clearCalendarEvent":
                clearCalendarEvent();
                break;
            case "sendVibrationStrength":
                sendVibrationStrength(call);
                break;
            case "queryVibrationStrength":
                queryVibrationStrength(result);
                break;
            default:
                result.notImplemented();
        }
    }

    private void queryVibrationStrength(MethodChannel.Result result) {
        bleConnection.queryVibrationStrength(vibrationStrength -> {
            String jsonStr = GsonUtils.get().toJson(vibrationStrength, CRPVibrationStrength.class);
            result.success(jsonStr);
        });
    }

    private void sendVibrationStrength(MethodCall call) {
        Integer value = call.argument("value");
        assert value != null;
        bleConnection.sendVibrationStrength(CRPVibrationStrength.getInstance(value.byteValue()));
    }

    private void clearCalendarEvent() {
        bleConnection.clearCalendarEvent();
    }

    private void queryCalendarEventReminderTime() {
        bleConnection.queryCalendarEventReminderTime();
    }

    private void sendCalendarEventReminderTime(MethodCall call) {
        String jsonStr = call.argument("calendarEventReminderTime");
        CalendarEventReminderTimeBean calendarEventReminderTime = GsonUtils.get().fromJson(jsonStr, CalendarEventReminderTimeBean.class);
        bleConnection.sendCalendarEventReminderTime(calendarEventReminderTime.isEnable(), calendarEventReminderTime.getMinutes());
    }

    private void queryCalendarEvent(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.queryCalendarEvent(id);
    }

    private void deleteCalendarEvent(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.deleteCalendarEvent(id);
    }

    private void sendCalendarEvent(MethodCall call) {
        String jsonStr = call.argument("calenderEventInfo");
        CRPCalendarEventInfo calendarEventInfo = GsonUtils.get().fromJson(jsonStr, CRPCalendarEventInfo.class);
        bleConnection.sendCalendarEvent(calendarEventInfo);
    }

    private void querySupportCalendarEvent() {
        bleConnection.querySupportCalendarEvent();
    }

    private void queryHistoryNewHrv() {
        bleConnection.queryHistoryNewHrv();
    }

    private void stopMeasureNewHrv() {
        bleConnection.stopMeasureNewHrv();
    }

    private void startMeasureNewHrv() {
        bleConnection.startMeasureNewHrv();
    }

    private void querySupportNewHrv() {
        bleConnection.querySupportNewHrv();
    }

    private void createBond(MethodCall call, MethodChannel.Result result) {
        String str = call.argument("keys");
        assert str != null;
        String[] keysStr = str.split(",");
        byte[] keys = new byte[keysStr.length];
        for (int i = 0; i < keysStr.length; i++) {
            keys[i] = Byte.parseByte(keysStr[i]);
        }
        bleConnection.createBond(keys, result::success);
    }

    private void queryLast24HourTemp() {
        bleConnection.queryLast24HourTemp();
    }

    private void queryContinueTempState() {
        bleConnection.queryContinueTempState();
    }

    private void disableContinueTemp() {
        bleConnection.disableContinueTemp();
    }

    private void enableContinueTemp() {
        bleConnection.enableContinueTemp();
    }

    private void sendGsensorCalibration() {
        bleConnection.sendGsensorCalibration();
    }

    private void queryTraining(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.queryTraining(id);
    }

    private void queryHistoryTraining() {
        bleConnection.queryHistoryTraining();
    }

    private void sendWakeState(MethodCall call) {
        Boolean enable = call.argument("enable");
        enable = enable != null && enable;
        bleConnection.sendTapToWakeState(enable);
    }

    private void queryWakeState(MethodChannel.Result result) {
        bleConnection.queryTapToWakeState(result::success);
    }

    private void querySupportStress() {
        bleConnection.querySupportStress();
    }

    private void startMeasureStress() {
        bleConnection.startMeasureStress();
    }

    private void stopMeasureStress() {
        bleConnection.stopMeasureStress();
    }

    private void queryHistoryStress() {
        bleConnection.queryHistoryStress();
    }

    private void enableTimingStress() {
        bleConnection.enableTimingStress();
    }

    private void disableTimingStress() {
        bleConnection.disableTimingStress();
    }

    private void queryTimingStressState() {
        bleConnection.queryTimingStressState();
    }

    private void queryTimingStress(MethodCall call) {
        String jsonStr = call.argument("stressDate");
        jsonStr = jsonStr == null ? CRPStressDate.TODAY.toString() : jsonStr;
        bleConnection.queryTimingStress(CRPStressDate.valueOf(jsonStr));
    }

    private void queryElectronicCardCount(MethodChannel.Result result) {
        bleConnection.queryElectronicCardCount(electronicCardCountInfo -> {
            String jsonStr = GsonUtils.get().toJson(electronicCardCountInfo, CRPElectronicCardCountInfo.class);
            result.success(jsonStr);
        });
    }

    private void sendElectronicCard(MethodCall call) {
        String jsonStr = call.argument("electronicCardInfo");
        CRPElectronicCardInfo electronicCardInfo = GsonUtils.get().fromJson(jsonStr, CRPElectronicCardInfo.class);
        bleConnection.sendElectronicCard(electronicCardInfo);
    }

    private void deleteElectronicCard(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.deleteElectronicCard(id);
    }

    private void queryElectronicCard(MethodCall call, MethodChannel.Result result) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.queryElectronicCard(id, electronicCardInfo -> {
            String jsonStr = GsonUtils.get().toJson(electronicCardInfo, CRPElectronicCardInfo.class);
            result.success(jsonStr);
        });
    }

    private void sendElectronicCardList(MethodCall call) {
        String jsonStr = call.argument("idList");
        if (jsonStr == null) return;
        String[] strArr = jsonStr.substring(1, jsonStr.length() - 1).split(",");
        ArrayList<Integer> idList = new ArrayList<>(strArr.length);
        for (String s : strArr) {
            idList.add(Integer.valueOf(s));
        }
        bleConnection.sendElectronicCardList(idList);
    }

    private void clearPillReminder() {
        bleConnection.clearPillReminder();
    }

    private void deletePillReminder(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.deletePillReminder(id);
    }

    private void sendPillReminder(MethodCall call) {
        String jsonStr = call.argument("pillReminderInfo");
        CRPPillReminderInfo pillReminderInfo = GsonUtils.get().fromJson(jsonStr,
                CRPPillReminderInfo.class);
        bleConnection.sendPillReminder(pillReminderInfo);
    }

    private void queryPillReminder(MethodChannel.Result result) {
        bleConnection.queryPillReminder((supportCount, list) -> {
            PillReminderBean pillReminderBean = new PillReminderBean();
            pillReminderBean.setSupportCount(supportCount);
            pillReminderBean.setList(list);
            String jsonStr = GsonUtils.get().toJson(pillReminderBean, PillReminderBean.class);
            result.success(jsonStr);
        });
    }

    private void sendBatterySaving(MethodCall call) {
        Boolean enable = call.argument("enable");
        enable = enable != null && enable;
        bleConnection.sendBatterySaving(enable);
    }

    private void queryBatterySaving() {
        bleConnection.queryBatterySaving();
    }

    private void clearContact() {
        bleConnection.clearContact();
    }

    private void deleteContact(MethodCall call) {
        Integer index = call.argument("index");
        if (index != null) {
            bleConnection.deleteContact(index);
        }
    }

    private void deleteContactAvatar(MethodCall call) {
        Integer index = call.argument("index");
        if (index != null) {
            bleConnection.deleteContactAvatar(index);
        }
    }

    private void sendContact(MethodCall call) {
        String jsonStr = call.argument("contactBean");
        ContactBean contactBean = GsonUtils.get().fromJson(jsonStr,
                ContactBean.class);
        CRPContactInfo crpContactInfo = new CRPContactInfo(
                contactBean.getId(),
                contactBean.getWidth(),
                contactBean.getHeight(),
                contactBean.getAddress(),
                contactBean.getName(),
                contactBean.getNumber());
        bleConnection.sendContact(crpContactInfo);
    }

    private void sendContactAvatar(MethodCall call) {
        BaseConnectionEventChannelHandler lazyEveChlHandler
                = connEveChlRegister.getLazyEveChlHandler(EVENT_CONTACT_AVATAR);
        if (lazyEveChlHandler != null) {
            lazyEveChlHandler.setConnListener(bleConnection, call);
        }
    }

    private void queryContactNumberSymbol(MethodChannel.Result result) {
        bleConnection.queryContactNumberSymbol(result::success);
    }

    private void queryContactCount(MethodChannel.Result result) {
        bleConnection.queryContactCount(result::success);
    }

    private void checkSupportQuickContact(MethodChannel.Result result) {
        bleConnection.checkSupportQuickContact(contactConfigInfo -> {
            String jsonStr = GsonUtils.get().toJson(contactConfigInfo, CRPContactConfigInfo.class);
            result.success(jsonStr);
        });
    }

    private void queryBtAddress(MethodChannel.Result result) {
        bleConnection.queryBtAddress(result::success);
    }

    private void queryBrightness(MethodChannel.Result result) {
        bleConnection.queryBrightness((current, max) -> {
            BrightnessBean brightness = new BrightnessBean(current, max);
            String jsonStr = GsonUtils.get().toJson(brightness, BrightnessBean.class);
            result.success(jsonStr);
        });
    }

    private void sendBrightness(MethodCall call) {
        Integer brightness = call.argument("brightness");
        brightness = brightness == null ? -1 : brightness;
        bleConnection.sendBrightness(brightness);
    }

    private void queryTempUnit() {
        bleConnection.queryTempUnit();
    }

    private void sendTempUnit(MethodCall call) {
        Integer temp = call.argument("temp");
        temp = temp == null ? 1 : temp;
        bleConnection.sendTempUnit(temp.byteValue());
    }

    private void sendLocalCity(MethodCall call) {
        String city = call.argument("city");
        bleConnection.sendLocalCity(city);
    }

    private void queryHandWashingReminderPeriod(MethodChannel.Result result) {
        bleConnection.queryHandWashingReminderPeriod(handWashingPeriodInfo -> {
            String jsonStr = GsonUtils.get().toJson(handWashingPeriodInfo, CRPHandWashingPeriodInfo.class);
            result.success(jsonStr);
        });
    }

    private void disableHandWashingReminder() {
        CRPHandWashingPeriodInfo handWashingPeriodInfo = new CRPHandWashingPeriodInfo(false, 0, 0, 0, 0);
        bleConnection.sendHandWashingReminder(handWashingPeriodInfo);
    }

    private void enableHandWashingReminder(MethodCall call) {
        String jsonStr = call.argument("handWashingPeriodInfo");
        CRPHandWashingPeriodInfo handWashingPeriodInfo = GsonUtils.get().fromJson(jsonStr,
                CRPHandWashingPeriodInfo.class);
        bleConnection.sendHandWashingReminder(handWashingPeriodInfo);
    }

    private void queryDisplayTime(MethodChannel.Result result) {
        bleConnection.queryDisplayTime(new CRPDeviceDisplayTimeCallback() {
            @Override
            public void onSupportAlwayOn(boolean b) {

            }

            @Override
            public void onDisplayTime(int time) {
                result.success(time);
            }
        });
    }

    private void sendDisplayTime(MethodCall call) {
        Integer time = call.argument("time");
        if (time != null && time % 5 == 0 && 0 < time && time <= 30) {
            bleConnection.sendDisplayTime(time);
        }
    }

    private void queryTimingMeasureTemp(MethodCall call) {
        String tempTimeType = call.argument("tempTimeType");
        tempTimeType = tempTimeType == null ? "TODAY" : tempTimeType;
        bleConnection.queryTimingMeasureTemp(CRPTempTimeType.valueOf(tempTimeType));
    }

    private void queryTimingMeasureTempState(MethodChannel.Result result) {
        bleConnection.queryTimingMeasureTempState(timingTempState -> {
            String jsonStr = GsonUtils.get().toJson(timingTempState, CRPTimingTempState.class);
            result.success(jsonStr);
        });
    }

    private void disableTimingMeasureTemp() {
        bleConnection.disableTimingMeasureTemp();
    }

    private void enableTimingMeasureTemp() {
        bleConnection.enableTimingMeasureTemp();
    }

    private void stopMeasureTemp() {
        bleConnection.stopMeasureTemp();
    }

    private void startMeasureTemp() {
        bleConnection.startMeasureTemp();
    }

    private void setTrainingState(MethodCall call) {
        Integer training = call.argument("training");
        training = training == null ? CRPMovementHeartRateStateType.MOVEMENT_COMPLETE : training;
        bleConnection.setMovementState(training.byteValue());
    }

    private void startTraining(MethodCall call) {
        Integer type = call.argument("type");
        type = type == null ? 0 : type;
        bleConnection.startMovement(type.byteValue());
    }

    private void queryMaxHeartRate(MethodChannel.Result result) {
        bleConnection.queryMaxHeartRate((heartRate, enable) -> {
            MaxHeartRateBean maxHeartRate = new MaxHeartRateBean(heartRate, enable);
            String jsonStr = GsonUtils.get().toJson(maxHeartRate, MaxHeartRateBean.class);
            result.success(jsonStr);
        });
    }

    private void setMaxHeartRate(MethodCall call) {
        String jsonStr = call.argument("maxHeartRateBean");
        MaxHeartRateBean maxHeartRate = GsonUtils.get().fromJson(jsonStr,
                MaxHeartRateBean.class);
        bleConnection.setMaxHeartRate(maxHeartRate.getHeartRate(), maxHeartRate.getEnable());
    }

    private void queryDrinkWaterReminderPeriod(MethodChannel.Result result) {
        bleConnection.queryDrinkWaterReminderPeriod(drinkWaterPeriodInfo -> {
            String jsonStr = GsonUtils.get().toJson(drinkWaterPeriodInfo, CRPDrinkWaterPeriodInfo.class);
            result.success(jsonStr);
        });
    }

    private void disableDrinkWaterReminder() {
        CRPDrinkWaterPeriodInfo drinkWaterPeriodInfo = new CRPDrinkWaterPeriodInfo(false, 0, 0, 0, 0);
        bleConnection.sendDrinkWaterReminder(drinkWaterPeriodInfo);
    }

    private void enableDrinkWaterReminder(MethodCall call) {
        String jsonStr = call.argument("drinkWaterPeriodInfo");
        CRPDrinkWaterPeriodInfo drinkWaterPeriodInfo = GsonUtils.get().fromJson(jsonStr,
                CRPDrinkWaterPeriodInfo.class);
        bleConnection.sendDrinkWaterReminder(drinkWaterPeriodInfo);
    }

    private void sendMaxVolume(MethodCall call) {
        Integer volume = call.argument("volume");
        volume = volume == null ? 0 : volume;
        bleConnection.sendMaxVolume(volume);
    }

    private void sendCurrentVolume(MethodCall call) {
        Integer volume = call.argument("volume");
        volume = volume == null ? 0 : volume;
        bleConnection.sendCurrentVolume(volume);
    }

    private void closePlayerControl() {
        bleConnection.closeMusicControl();
    }

    private void sendLyrics(MethodCall call) {
        bleConnection.sendLyrics(call.argument("lyrics"));
    }

    private void sendSongTitle(MethodCall call) {
        bleConnection.sendSongTitle(call.argument("title"));
    }

    private void setPlayerState(MethodCall call) {
        Integer type = call.argument("musicPlayerStateType");
        type = type == null ? CRPMusicPlayerStateType.MUSIC_PLAYER_PAUSE : type;
        bleConnection.setMusicPlayerState(type.byteValue());
    }

    private void stopFindPhone() {
        bleConnection.stopFindPhone();
    }

    private void startFindPhone() {
        bleConnection.startFindPhone();
    }

    private void sendMenstrualCycle(MethodCall call) {
        String jsonStr = call.argument("menstrualCycleBean");

        MenstrualCycleBean menstrualCycleBean = GsonUtils.get().fromJson(jsonStr,
                MenstrualCycleBean.class);
        bleConnection.sendPhysiologcalPeriod(MenstrualCycleBean.convert(menstrualCycleBean));
    }

    private void queryMenstrualCycle(MethodChannel.Result result) {
        bleConnection.queryPhysiologcalPeriod(physiologcalPeriodInfo -> {
            String jsonStr = GsonUtils.get().toJson(physiologcalPeriodInfo, CRPPhysiologcalPeriodInfo.class);
            result.success(jsonStr);
        });
    }

    private void getProtocolVersion(MethodChannel.Result result) {
        String jsonStr = GsonUtils.get().toJson(bleConnection.getProtocolVersion());
        result.success(jsonStr);
    }

    private void sendFutureWeather(MethodCall call) {
        String jsonStr = call.argument("futureWeatherInfo");
        CRPFutureWeatherInfo futureWeatherInfo = GsonUtils.get().fromJson(jsonStr,
                CRPFutureWeatherInfo.class);
        bleConnection.sendFutureWeather(futureWeatherInfo);
    }

    private void sendTodayWeather(MethodCall call) {
        String jsonStr = call.argument("todayWeatherInfo");
        CRPTodayWeatherInfo todayWeatherInfo = GsonUtils.get().fromJson(jsonStr,
                CRPTodayWeatherInfo.class);
        bleConnection.sendTodayWeather(todayWeatherInfo);
    }

    private void sendStepLength(MethodCall call) {
        Integer stepLength = call.argument("stepLength");
        stepLength = stepLength == null ? -1 : stepLength;
        bleConnection.sendStepLength(stepLength.byteValue());
    }

    private void sendUserInfo(MethodCall call) {
        String jsonStr = call.argument("userInfo");
        CRPUserInfo userInfo = GsonUtils.get().fromJson(jsonStr, CRPUserInfo.class);
        bleConnection.sendUserInfo(userInfo);
    }

    private void sendTimeSystem(@NonNull MethodCall call) {
        Integer timeSystemType = call.argument("timeSystemType");
        timeSystemType = timeSystemType == null ? CRPTimeSystemType.TIME_SYSTEM_12 : timeSystemType;

        bleConnection.sendTimeSystem(timeSystemType.byteValue());
    }

    private void queryTimeSystem(MethodChannel.Result result) {
        bleConnection.queryTimeSystem(result::success);
    }

    private void queryDeviceBattery() {
        bleConnection.queryDeviceBattery();
    }

    private void subscribeDeviceBattery() {
        bleConnection.subscribeDeviceBattery();
    }

    private void queryFirmwareVersion(MethodChannel.Result result) {
        bleConnection.queryFrimwareVersion(result::success);
    }

    private void checkFirmwareVersion(MethodCall call, MethodChannel.Result result) {
        String jsonStr = call.argument("firmwareVersion");
        FirmwareVersionBean firmwareVersionBean = GsonUtils.get().fromJson(jsonStr, FirmwareVersionBean.class);

        if (bleConnection == null) {
            result.success(null);
            return;
        }

        bleConnection.checkFirmwareVersion(new CRPDeviceNewFirmwareVersionCallback() {
            @Override
            public void onNewFirmwareVersion(CRPFirmwareVersionInfo firmwareVersionInfo) {
                CheckFirmwareVersionBean firmwareVersionBean = new CheckFirmwareVersionBean();
                firmwareVersionBean.setIsLatestVersion(false);
                firmwareVersionBean.setFirmwareVersionInfo(firmwareVersionInfo);
                String jsonStr = GsonUtils.get().toJson(firmwareVersionBean, CheckFirmwareVersionBean.class);
                result.success(jsonStr);
            }

            @Override
            public void onLatestVersion() {
                CheckFirmwareVersionBean firmwareVersionBean = new CheckFirmwareVersionBean();
                firmwareVersionBean.setIsLatestVersion(true);
                String jsonStr = GsonUtils.get().toJson(firmwareVersionBean, CheckFirmwareVersionBean.class);
                result.success(jsonStr);
            }
        }, firmwareVersionBean.getVersion(), firmwareVersionBean.getOtaType());
    }

    public CRPBleConnection connect(@NonNull MethodCall call, Context context) {
        String address = call.argument("address");
        bleDevice = CRPBleClient.create(context.getApplicationContext()).getBleDevice(address);
        if (bleDevice == null) {
            return null;
        }
        CRPBleConnection connection = bleDevice.connect();
        if (connection == null) {
            return null;
        }

        for (BaseConnectionEventChannelHandler handler : connEveChlRegister.defaultConnHandlerList) {
            handler.setConnListener(connection, call);
        }
        return connection;
    }

    private void isConnected(MethodCall call, MethodChannel.Result result) {
        String address = call.argument("address");
        result.success(isConnected(address));
    }

    private boolean isConnected(String address) {
        CRPBleDevice mBleDevice = bleClient.getBleDevice(address);
        return isConnected || (mBleDevice != null && mBleDevice.isConnected());
    }

    private boolean checkBluetoothEnable() {
        if (bleClient != null) {
            return bleClient.isBluetoothEnable();
        } else {
            return false;
        }
    }

    private void disconnect(MethodChannel.Result result) {
        if (bleDevice != null) {
            bleDevice.disconnect();
            isConnected = false;
        }

        result.success(true);
    }

    private void closeGatt(MethodChannel.Result result) {
        if (bleConnection != null) {
            bleConnection.close();
            bleConnection = null;
            result.success(true);
        }
    }

    private void querySteps() {
        bleConnection.syncStep();
    }

    private void queryHistorySteps(MethodCall call) {
        Integer historyTimeType = call.argument("historyTimeType");
        historyTimeType = historyTimeType == null ?
                0 : historyTimeType;
        bleConnection.queryHistoryStep(CRPHistoryDay.getInstance(historyTimeType.byteValue()));
    }

    private void queryStepsDetail(MethodCall call) {
        Integer stepsDetailDateType = call.argument("stepsDetailDateType");
        stepsDetailDateType = stepsDetailDateType == null ?
                CRPHistoryDay.YESTERDAY.getValue() : stepsDetailDateType;
        bleConnection.queryStepsCategory(CRPHistoryDay.getInstance(stepsDetailDateType.byteValue()));
    }

    private void queryActionDetails(MethodCall call) {
        Integer actionDetailsType = call.argument("actionDetailsType");
        actionDetailsType = actionDetailsType == null ?
                CRPHistoryDay.YESTERDAY.getValue() : actionDetailsType;
        bleConnection.queryActionDetails(CRPHistoryDay.getInstance(actionDetailsType.byteValue()));
    }

    private void querySleep() {
        bleConnection.syncSleep();
    }

    private void queryRemSleep() {
        bleConnection.syncRemSleep();
    }

    private void sendGoalSleepTime(MethodCall call) {
        Integer goalTime = call.argument("goalTime");
        goalTime = goalTime == null ?
                100 : goalTime;
        bleConnection.sendGoalSleepTime(goalTime);
    }

    private void queryGoalSleepTime() {
        bleConnection.queryGoalSleepTime();
    }

    private void queryHistorySleep(MethodCall call) {
        Integer historyTimeType = call.argument("historyTimeType");
        historyTimeType = historyTimeType == null ?
                0 : historyTimeType;
        bleConnection.queryHistorySleep(CRPHistoryDay.getInstance(historyTimeType.byteValue()));
    }

    private void startOTA(MethodCall call) {
        String jsonStr = call.argument("otaBean");
        OTABean otaBean = GsonUtils.get().fromJson(jsonStr,
                OTABean.class);
        OTAController otaController = new OTAController(otaBean.getType(), connEveChlRegister, call, bleConnection);
        otaController.startOTA();
    }

    private void abortOTA(MethodCall call) {
        Integer type = call.argument("type");
        type = type == null ? OTAController.START_DEFAULT_OTA : type;
        OTAController otaController = new OTAController(type, connEveChlRegister, call, bleConnection);
        otaController.abortOTA();
    }

    private void queryDeviceOtaStatus(MethodChannel.Result result) {
        bleConnection.queryDeviceDfuStatus(result::success);
    }

    private void queryHsOtaAddress(MethodChannel.Result result) {
        bleConnection.queryHsDfuAddress(result::success);
    }

    private void enableHsOta() {
        bleConnection.enableHsDfu();
    }

    private void queryOtaType(MethodChannel.Result result) {
        bleConnection.queryDfuType(result::success);
    }

    private void queryUnitSystem(MethodChannel.Result result) {
        bleConnection.queryMetricSystem(result::success);
    }

    private void sendUnitSystem(MethodCall call) {
        Integer metricSystemType = call.argument("metricSystemType");
        metricSystemType = metricSystemType == null ?
                CRPMetricSystemType.METRIC_SYSTEM : metricSystemType;

        bleConnection.sendMetricSystem(metricSystemType.byteValue());
    }

    private void sendQuickView(MethodCall call) {
        Boolean quickViewState = call.argument("quickViewState");
        quickViewState = quickViewState != null && quickViewState;

        bleConnection.sendQuickView(quickViewState);
    }

    private void queryQuickView(MethodChannel.Result result) {
        bleConnection.queryQuickView(result::success);
    }

    private void sendQuickViewTime(MethodCall call) {
        String jsonStr = call.argument("periodTimeInfo");
        CRPPeriodTimeInfo periodTimeInfo = GsonUtils.get().fromJson(jsonStr,
                CRPPeriodTimeInfo.class);

        bleConnection.sendQuickViewTime(periodTimeInfo);
    }

    private void queryQuickViewTime(MethodChannel.Result result) {
        bleConnection.queryQuickViewTime((int periodTimeType, CRPPeriodTimeInfo periodTimeInfo) -> {
            PeriodTimeBean quickViewTime = new PeriodTimeBean(periodTimeType, periodTimeInfo);
            String jsonStr = GsonUtils.get().toJson(quickViewTime, PeriodTimeBean.class);
            result.success(jsonStr);
        });
    }

    private void sendGoalSteps(MethodCall call) {
        Integer goalSteps = call.argument("goalSteps");
        goalSteps = goalSteps == null ? 8000 : goalSteps;

        bleConnection.sendGoalSteps(goalSteps);
    }

    private void queryGoalSteps(MethodChannel.Result result) {
        bleConnection.queryGoalStep(result::success);
    }

    private void sendDailyGoals(MethodCall call) {
        String jsonStr = call.argument("dailyGoals");
        CRPDailyGoalsInfo dailyGoalsInfo = GsonUtils.get().fromJson(jsonStr,
                CRPDailyGoalsInfo.class);
        bleConnection.sendDailyGoals(dailyGoalsInfo);
    }

    private void queryDailyGoals(MethodChannel.Result result) {
        bleConnection.queryDailyGoals(dailyGoalsInfo -> {
            String jsonStr = GsonUtils.get().toJson(dailyGoalsInfo, CRPDailyGoalsInfo.class);
            result.success(jsonStr);
        });
    }

    private void sendTrainingDayGoals(MethodCall call) {
        String jsonStr = call.argument("dailyGoals");
        CRPDailyGoalsInfo dailyGoalsInfo = GsonUtils.get().fromJson(jsonStr,
                CRPDailyGoalsInfo.class);
        bleConnection.sendTrainingDayGoals(dailyGoalsInfo);
    }

    private void queryTrainingDayGoals(MethodChannel.Result result) {
        bleConnection.queryTrainingDayGoals(new CRPTrainingDayGoalsCallback() {
            @Override
            public void onTrainingDayGoals(CRPDailyGoalsInfo dailyGoalsInfo) {
                String jsonStr = GsonUtils.get().toJson(dailyGoalsInfo, CRPDailyGoalsInfo.class);
                result.success(jsonStr);
            }

            @Override
            public void onTrainingDays(CRPTrainingDayInfo trainingDayInfo) {
            }
        });
    }

    private void sendTrainingDays(MethodCall call) {
        String jsonStr = call.argument("trainingDay");
        TrainingDaysBean trainingDays = GsonUtils.get().fromJson(jsonStr,
                TrainingDaysBean.class);
        CRPTrainingDayInfo trainingDayInfo = new CRPTrainingDayInfo(trainingDays.getEnable(), trainingDays.getTrainingDays());
        bleConnection.sendTrainingDays(trainingDayInfo);
    }

    private void queryTrainingDay(MethodChannel.Result result) {
        bleConnection.queryTrainingDay(new CRPTrainingDayGoalsCallback() {
            @Override
            public void onTrainingDayGoals(CRPDailyGoalsInfo dailyGoalsInfo) {
            }

            @Override
            public void onTrainingDays(CRPTrainingDayInfo trainingDayInfo) {
                byte trainingDays = trainingDayInfo.getTrainingDays();
                StringBuilder trainingDaysStr = new StringBuilder(Integer.toBinaryString(trainingDays));
                trainingDaysStr.reverse();
                List<Integer> list = new ArrayList<>();
                for (int i = trainingDaysStr.length() - 1; i >= 0; i--) {
                    if (trainingDaysStr.charAt(i) == '1') {
                        list.add(i);
                    }
                }
                int[] trainingDayList = new int[list.size()];
                for (int i = 0; i < list.size(); i++) {
                    trainingDayList[i] = list.get(i);
                }
                TrainingDaysBean trainingDay = new TrainingDaysBean(trainingDayInfo.isEnable(), trainingDayList);
                String jsonStr = GsonUtils.get().toJson(trainingDay, TrainingDaysBean.class);
                result.success(jsonStr);

            }
        });
    }

    private void sendDisplayWatchFace(MethodCall call) {
        Integer watchFaceType = call.argument("watchFaceType");
        watchFaceType = watchFaceType == null ? CRPWatchFaceType.FIRST_WATCH_FACE : watchFaceType;

        bleConnection.sendDisplayWatchFace(watchFaceType.byteValue());
    }

    private void queryDisplayWatchFace(MethodChannel.Result result) {
        bleConnection.queryDisplayWatchFace(result::success);
    }

    private void queryWatchFaceLayout(MethodChannel.Result result) {
        bleConnection.queryWatchFaceLayout(crpWatchFaceLayoutInfo -> {
            String jsonStr = GsonUtils.get().toJson(crpWatchFaceLayoutInfo, CRPWatchFaceLayoutInfo.class);
            result.success(jsonStr);
        });
    }

    private void sendWatchFaceLayout(MethodCall call) {
        String jsonStr = call.argument("watchFaceLayoutInfo");
        CRPWatchFaceLayoutInfo watchFaceLayoutInfo = GsonUtils.get().fromJson(jsonStr, CRPWatchFaceLayoutInfo.class);

        bleConnection.sendWatchFaceLayout(watchFaceLayoutInfo);
    }

    private void abortWatchFaceBackground() {
        bleConnection.abortWatchFaceBackground();
    }

    private void sendWatchFaceBackground(MethodCall call) {
        BaseConnectionEventChannelHandler lazyEveChlHandler
                = connEveChlRegister.getLazyEveChlHandler(EVENT_FILE_TRANS);
        if (lazyEveChlHandler != null) {
            lazyEveChlHandler.setConnListener(bleConnection, call);
        }
    }

    private void querySupportWatchFace(MethodChannel.Result result) {
        bleConnection.querySupportWatchFace(new CRPDeviceSupportWatchFaceCallback() {
            @Override
            public void onSupportWatchFace(CRPSupportWatchFaceInfo crpSupportWatchFaceInfo) {
                String jsonStr = GsonUtils.get().toJson(crpSupportWatchFaceInfo, CRPSupportWatchFaceInfo.class);
                result.success(jsonStr);
            }

            @Override
            public void onSifliSupportWatchFace(CRPSifliSupportWatchFaceInfo crpSifliSupportWatchFaceInfo) {

            }
        });
    }

    private void queryWatchFaceStore(MethodCall call, MethodChannel.Result result) {
        String jsonStr = call.argument("watchFaceStoreBean");
        WatchFaceStoreBean watchFaceLayoutInfo = GsonUtils.get().fromJson(jsonStr, WatchFaceStoreBean.class);

        bleConnection.queryWatchFaceStore(watchFaceLayoutInfo.getWatchFaceSupportList(), watchFaceLayoutInfo.getFirmwareVersion(),
                watchFaceLayoutInfo.getPageCount(), watchFaceLayoutInfo.getPageIndex(), new CRPDeviceWatchFaceStoreCallback() {
                    @Override
                    public void onWatchFaceStoreChange(CRPWatchFaceStoreInfo watchFaceStoreInfo) {
                        WatchFaceStoreListBean watchFaceStoreListBean = new WatchFaceStoreListBean(watchFaceStoreInfo, "noError");
                        String jsonStr = GsonUtils.get().toJson(watchFaceStoreListBean, WatchFaceStoreListBean.class);
                        result.success(jsonStr);
                    }

                    @Override
                    public void onError(String error) {
                        CRPWatchFaceStoreInfo watchFaceStoreInfo = new CRPWatchFaceStoreInfo(-1, -1, -1, new LinkedList<>());
                        WatchFaceStoreListBean watchFaceStore = new WatchFaceStoreListBean(watchFaceStoreInfo, error);
                        String jsonStr = GsonUtils.get().toJson(watchFaceStore, WatchFaceStoreListBean.class);
                        result.success(jsonStr);
                    }
                });
    }

    private void queryWatchFaceOfID(MethodCall call, MethodChannel.Result result) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.queryWatchFaceOfID(id, new CRPDeviceWatchFaceCallback() {

            @Override
            public void onWatchFaceChange(CRPWatchFaceStoreInfo.WatchFaceBean watchFaceBean) {
                int result_OK = 0;
                WatchFaceIDBean watchFaceID = new WatchFaceIDBean(result_OK);
                watchFaceID.setWatchFace(watchFaceBean);
                watchFaceID.setError("");
                String jsonStr = GsonUtils.get().toJson(watchFaceID, WatchFaceIDBean.class);
                result.success(jsonStr);
            }

            @Override
            public void onError(String error) {
                int errorCode = 101;
                WatchFaceIDBean watchFaceID = new WatchFaceIDBean(errorCode);
                watchFaceID.setError(error);
                watchFaceID.setWatchFace(new CRPWatchFaceStoreInfo.WatchFaceBean(-1, null, null));
                String jsonStr = GsonUtils.get().toJson(watchFaceID, WatchFaceIDBean.class);
                result.success(jsonStr);
            }
        });
    }

    private void sendWatchFace(MethodCall call) {
        BaseConnectionEventChannelHandler lazyEveChlHandler
                = connEveChlRegister.getLazyEveChlHandler(EVENT_WF_FILE_TRANS);
        if (lazyEveChlHandler != null) {
            lazyEveChlHandler.setConnListener(bleConnection, call);
        }
    }

    private void abortWatchFace() {
        bleConnection.abortWatchFace();
    }

    private void deleteWatchFace(MethodCall call, MethodChannel.Result result) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.deleteWatchFace(id, new CRPWatchFaceDeleteCallback() {
            @Override
            public void onComplete() {
                result.success("f");
            }

            @Override
            public void onError() {
                result.success("f");
            }
        });
    }

    private void queryAvailableStorage(MethodChannel.Result result) {
        bleConnection.queryAvailableStorage(result::success);
    }

    private void sendAlarm(MethodCall call) {
        String jsonStr = call.argument("alarmClockInfo");
        CRPAlarmInfo alarmClockInfo = GsonUtils.get().fromJson(jsonStr, CRPAlarmInfo.class);

        bleConnection.sendAlarm(alarmClockInfo);
    }

    private void queryAllAlarm(MethodChannel.Result result) {
        bleConnection.queryAllAlarm(new CRPAlarmCallback() {
            @Override
            public void onAlarmList(List<CRPAlarmInfo> list) {
                List<String> jsonStr = new ArrayList<>();
                for (int i = 0; i < list.size(); i++) {
                    jsonStr.add(GsonUtils.get().toJson(list.get(i), CRPAlarmInfo.class));
                }
                result.success(jsonStr.toString());
            }

            @Override
            public void onNewAlarmList(List<CRPAlarmInfo> list) {
                List<String> jsonStr = new ArrayList<>();
                for (int i = 0; i < list.size(); i++) {
                    jsonStr.add(GsonUtils.get().toJson(list.get(i), CRPAlarmInfo.class));
                }
                result.success(jsonStr.toString());
            }
        });
    }

    private void sendNewAlarm(MethodCall call) {
        String jsonStr = call.argument("alarmClockInfo");
        CRPAlarmInfo alarmInfo = GsonUtils.get().fromJson(jsonStr, CRPAlarmInfo.class);
        bleConnection.sendNewAlarm(alarmInfo);
    }

    private void deleteNewAlarm(MethodCall call) {
        Integer id = call.argument("id");
        id = id == null ? -1 : id;
        bleConnection.deleteNewAlarm(id);
    }

    private void deleteAllNewAlarm() {
        bleConnection.deleteAllNewAlarm();
    }

    private void queryAllNewAlarm(MethodChannel.Result result) {
        bleConnection.queryAllNewAlarm(new CRPAlarmCallback() {

            @Override
            public void onAlarmList(List<CRPAlarmInfo> list) {
                ArrayList<String> jsonList = new ArrayList<>();
                for (int i = 0; i < list.size(); i++) {
                    jsonList.add(GsonUtils.get().toJson(list.get(i), CRPAlarmInfo.class));
                }
                result.success(jsonList.toString());
            }

            @Override
            public void onNewAlarmList(List<CRPAlarmInfo> list) {
                ArrayList<String> jsonList = new ArrayList<>();
                for (int i = 0; i < list.size(); i++) {
                    jsonList.add(GsonUtils.get().toJson(list.get(i), CRPAlarmInfo.class));
                }
                result.success(jsonList.toString());
            }
        });
    }

    private void queryLastDynamicRate(MethodCall call) {
        String type = call.argument("type");
        type = type == null ? CRPHistoryDynamicRateType.FIRST_HEART_RATE.toString() : type;
        bleConnection.queryLastDynamicRate(CRPHistoryDynamicRateType.valueOf(type));
    }

    private void enableTimingMeasureHeartRate(MethodCall call) {
        Integer interval = call.argument("interval");
        interval = interval == null ? 5 : interval;
        bleConnection.enableTimingMeasureHeartRate(interval);
    }

    private void disableTimingMeasureHeartRate() {
        bleConnection.disableTimingMeasureHeartRate();
    }

    private void queryTimingMeasureHeartRate(MethodChannel.Result result) {
        bleConnection.queryTimingMeasureHeartRate(result::success);
    }

    private void queryTodayHeartRate(MethodCall call) {
        Integer heartRateType = call.argument("heartRateType");
        heartRateType = heartRateType == null ? CRPHeartRateType.ALL_DAY_HEART_RATE : heartRateType;
        bleConnection.queryTodayHeartRate(heartRateType);
    }

    private void queryPastHeartRate(MethodCall call) {
        Integer historyDay = call.argument("historyDay");
        historyDay = historyDay == null ?
                1 : historyDay;
        bleConnection.queryHistoryTimingHeartRate(CRPHistoryDay.getInstance(historyDay.byteValue()));
    }

    private void queryTrainingHeartRate() {
        bleConnection.queryMovementHeartRate();
    }

    private void startMeasureOnceHeartRate() {
        bleConnection.startMeasureOnceHeartRate();
    }

    private void stopMeasureOnceHeartRate() {
        bleConnection.stopMeasureOnceHeartRate();
    }

    private void queryHistoryHeartRate() {
        bleConnection.queryHistoryHeartRate();
    }

    //血压
    private void startMeasureBloodPressure() {
        bleConnection.startMeasureBloodPressure();
    }

    private void stopMeasureBloodPressure() {
        bleConnection.stopMeasureBloodPressure();
    }

    private void enableContinueBloodPressure() {
        bleConnection.enableContinueBloodPressure();
    }

    private void disableContinueBloodPressure() {
        bleConnection.disableContinueBloodPressure();
    }

    private void queryContinueBloodPressureState() {
        bleConnection.queryContinueBloodPressureState();
    }

    private void queryLast24HourBloodPressure() {
        bleConnection.queryLast24HourBloodPressure();
    }

    private void queryHistoryBloodPressure() {
        bleConnection.queryHistoryBloodPressure();
    }

    private void startMeasureBloodOxygen() {
        bleConnection.startMeasureBloodOxygen();
    }

    private void stopMeasureBloodOxygen() {
        bleConnection.stopMeasureBloodOxygen();
    }

    private void enableTimingMeasureBloodOxygen(MethodCall call) {
        Integer interval = call.argument("interval");
        interval = interval == null ? 5 : interval;
        bleConnection.enableTimingMeasureBloodOxygen(interval);
    }

    private void disableTimingMeasureBloodOxygen() {
        bleConnection.disableTimingMeasureBloodOxygen();
    }

    private void queryTimingBloodOxygenMeasureState() {
        bleConnection.queryTimingBloodOxygenMeasureState();
    }

    private void queryTimingBloodOxygen(MethodCall call) {
        String bloodOxygenTimeType = call.argument("bloodOxygenTimeType");
        bloodOxygenTimeType = bloodOxygenTimeType == null ? CRPBloodOxygenTimeType.TODAY.toString() : bloodOxygenTimeType;
        bleConnection.queryTimingBloodOxygen(CRPBloodOxygenTimeType.valueOf(bloodOxygenTimeType));
    }

    private void enableContinueBloodOxygen() {
        bleConnection.enableContinueBloodOxygen();
    }

    private void disableContinueBloodOxygen() {
        bleConnection.disableContinueBloodOxygen();
    }

    private void queryContinueBloodOxygenState() {
        bleConnection.queryContinueBloodOxygenState();
    }


    private void queryLast24HourBloodOxygen() {
        bleConnection.queryLast24HourBloodOxygen();
    }

    private void queryHistoryBloodOxygen() {
        bleConnection.queryHistoryBloodOxygen();
    }

    private void enterCameraView() {
        bleConnection.enterCameraView();
    }

    private void sendDelayTaking(MethodCall call) {
        Integer delayTime = call.argument("delayTime");
        delayTime = delayTime == null ? 100 : delayTime;
        bleConnection.sendDelayTaking(delayTime);
    }

//    private void queryDelayTaking() {
//        bleConnection.queryDelayTaking();
//    }

    private void exitCameraView() {
        bleConnection.exitCameraView();
    }

    private void readDeviceRssi() {
        bleConnection.readDeviceRssi();
    }

    private void setECGChangeListener(MethodCall call) {
        BaseConnectionEventChannelHandler lazyEveChlHandler
                = connEveChlRegister.getLazyEveChlHandler(EVENT_ECG);
        if (lazyEveChlHandler != null) {
            lazyEveChlHandler.setConnListener(bleConnection, call);
        }
    }

    private void startECGMeasure() {
        bleConnection.startECGMeasure();
    }

    private void stopECGMeasure() {
        bleConnection.stopECGMeasure();
    }

    private void isNewECGMeasurementVersion(MethodChannel.Result result) {
        boolean newMeasurementVersion = bleConnection.isNewECGMeasurementVersion();
        result.success(newMeasurementVersion);

    }

    private void queryLastMeasureECGData() {
        bleConnection.queryLastMeasureECGData();
    }

    private void sendECGHeartRate(MethodCall call) {
        Integer heartRate = call.argument("heartRate");
        heartRate = heartRate == null ? 0 : heartRate;
        bleConnection.sendECGHeartRate(heartRate);
    }

    private void sendDeviceLanguage(MethodCall call) {
        Integer language = call.argument("language");
        language = language == null ? CRPDeviceLanguageType.LANGUAGE_CHINESE : language;
        // Simplified Chinese is set to the Chinese version, non-simplified Chinese is set to the international version
        byte version = CRPDeviceVersionType.INTERNATIONAL_EDITION;
        if (language == CRPDeviceLanguageType.LANGUAGE_CHINESE) {
            version = CRPDeviceVersionType.CHINESE_EDITION;
        }
        bleConnection.sendDeviceVersion(version);
        bleConnection.sendDeviceLanguage(language.byteValue());
    }

    private void queryDeviceVersion(MethodChannel.Result result) {
        bleConnection.queryDeviceVersion(result::success);
    }

    private void queryDeviceLanguage(MethodChannel.Result result) {
        bleConnection.queryDeviceLanguage((int type, int[] languageType) -> {

            DeviceLanguageBean deviceLanguage = new DeviceLanguageBean(type, languageType);
            String jsonStr = GsonUtils.get().toJson(deviceLanguage, DeviceLanguageBean.class);
            result.success(jsonStr);
        });
    }

    private void sendOtherMessageState(MethodCall call) {
        Boolean state = call.argument("state");
        bleConnection.sendOtherMessageState(Boolean.TRUE.equals(state));
    }

    private void queryOtherMessageState(MethodChannel.Result result) {
        bleConnection.queryOtherMessageState(result::success);
    }

    private void sendMessage(MethodCall call) {
        String jsonStr = call.argument("messageInfo");
        CRPMessageInfo messageInfo = GsonUtils.get().fromJson(jsonStr, CRPMessageInfo.class);
        NotificationTypeBean notificationType = new NotificationTypeBean(messageInfo.getType(), messageInfo.getMessage());
        messageInfo.setMessage(notificationType.getMessage());
        bleConnection.sendMessage(messageInfo);
    }

    private void endCall() {
        bleConnection.sendCall0ffHook();
    }

    private void sendCallContactName(MethodCall call) {
        String jsonStr = call.argument("name");
        bleConnection.sendCallContactName(jsonStr);
    }

    private void queryMessageList(MethodChannel.Result result) {
        bleConnection.queryMessageList(list -> {
            StringBuilder listStr = new StringBuilder();
            for (int i = 0; i < list.size(); i++) {
                listStr.append(list.get(i)).append(",");
            }
            listStr.delete(listStr.length() - 1, listStr.length());
            result.success(listStr);
        });
    }

    private void sendSedentaryReminder(MethodCall call) {
        Boolean sedentaryReminder = call.argument("sedentaryReminder");
        sedentaryReminder = sedentaryReminder != null && sedentaryReminder;
        bleConnection.sendSedentaryReminder(sedentaryReminder);
    }

    private void querySedentaryReminder(MethodChannel.Result result) {
        bleConnection.querySedentaryReminder(result::success);
    }

    private void sendSedentaryReminderPeriod(MethodCall call) {
        String jsonStr = call.argument("sedentaryReminderPeriodInfo");
        CRPSedentaryReminderPeriodInfo sedentaryReminderPeriodInfo =
                GsonUtils.get().fromJson(jsonStr, CRPSedentaryReminderPeriodInfo.class);
        bleConnection.sendSedentaryReminderPeriod(sedentaryReminderPeriodInfo);
    }

    private void querySedentaryReminderPeriod(MethodChannel.Result result) {
        bleConnection.querySedentaryReminderPeriod(sedentaryReminderPeriodInfo -> {
            String jsonStr = GsonUtils.get().toJson(sedentaryReminderPeriodInfo, CRPSedentaryReminderPeriodInfo.class);
            result.success(jsonStr);
        });
    }

    private void findDevice() {
        bleConnection.findDevice();
    }

    private void shutDown() {
        bleConnection.shutDown();
    }

    private void reset() {
        bleConnection.reset();
    }

    private void sendDoNotDisturbTime(MethodCall call) {
        String jsonStr = call.argument("periodTimeInfo");
        CRPPeriodTimeInfo periodTimeInfo =
                GsonUtils.get().fromJson(jsonStr, CRPPeriodTimeInfo.class);
        bleConnection.sendDoNotDistrubTime(periodTimeInfo);
    }

    private void queryDoNotDisturbTime(MethodChannel.Result result) {
        bleConnection.queryDoNotDistrubTime((periodTimeType, periodTimeInfo) -> {
            PeriodTimeBean doNotDisturbTime = new PeriodTimeBean(periodTimeType, periodTimeInfo);
            String jsonStr = GsonUtils.get().toJson(doNotDisturbTime, PeriodTimeBean.class);
            result.success(jsonStr);
        });
    }

    private void sendBreathingLight(MethodCall call) {
        Boolean breathingLight = call.argument("breathingLight");
        breathingLight = breathingLight != null && breathingLight;
        bleConnection.sendBreathingLight(breathingLight);
    }

    private void queryBreathingLight(MethodChannel.Result result) {
        bleConnection.queryBreathingLight(result::success);
    }

}
